% uza7.m
% fd, 28, 30  janvier 2006.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlabel (' uza7.  Optimisation sous contraintes inegalites. \
Algorithme de Uzawa.  ') ;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
a=2 ; b=0 ; al0=2; be0=1 ;
%  axis ( [-2.1 , 2.1 , -2.1, 2.1],'square' );
   axis ( [ a-4.1 , a+4.1 , b-2.1, b+2.1] );

n=300 ; 
dth=2*pi/n ; 
xx=zeros(n+1,1); yy= zeros(n+1,1) ; 

th=0;  
hold off ; for j=1:n+1 ; 
y = 2 * sin(th) / sqrt(3) ; 
xx(j:j,1) = y/2 + cos(th) ; 
yy(j:j,1) = y ;  th=th+dth; end;
plot (xx,yy,'b;;') ; 
hold on 

th=0;  for j=1:n+1 ; 
y = 2 * sin(th) / sqrt(3) ; 
xx(j:j,1) = -y/2 + cos(th) ; 
yy(j:j,1) = y ;  th=th+dth; end;
plot (xx,yy,'b;;')

dr=.1; rr=.1 ; 
for j=1:20;
al=rr*al0 ; be=rr*be0 ; 
dth=ellips (a,b,al,be);
rr=rr+dr;
end;

xx = -1.5  ; yy = 1 ; 
plot (xx,yy ,'r*;;')

A = [ 2*xx+yy , 2*xx-yy ; xx+2*yy , -xx+2*yy ] ; 
bb= [ -(xx-a)/al0**2 ; -(yy-b)/be0**2 ] ;
xi = A \ bb ;  lambda = xi(1:1,1)  ;   mu = xi(2:2,1)  ;   

     for j = 1 :55 
A = [ 1/al0**2 + 2*(lambda+mu) ,  lambda-mu ;  lambda-mu , 1/be0**2 + 2*(lambda+mu) ] ; 
bb= [ a/al0**2 ; b/be0**2 ] ;
xi = A \ bb ;  xx1 = xi(1:1,1)   ; yy1 = xi(2:2,1) ;  
plot (xx1,yy1 ,'b*;;', [xx xx1], [yy yy1], 'r;;') ;;    
xx=xx1 ; yy=yy1 ; 

dgx = xx**2 + xx*yy + yy**2 - 1 ; 
dgy = xx**2 - xx*yy + yy**2 - 1  ; 
rho = .1 ; 
lprov = lambda + rho * dgx ;  
mprov     = mu     + rho * dgy  ;  
[lambda , mu] = proj2(lprov , mprov ) ; 
end 


pause 
   axis ( [ -1.1 , 1.1 , -1.1, 1.1] );

eps=.1 ;  
for j = 1 : 4
pause  
axis ( [ 1 - eps  , 1 + eps  ,   - eps  ,  + eps ] );
eps = eps / 10 ; 
end ; 


hold off

